Given an array of N elements, the task is to find all the unique pairs that can be formed using the elements of a given array.
Examples:
Input: arr[] = {1, 1, 2}
Output: 4
(1, 1), (1, 2), (2, 1), (2, 2) are the only possible pairs.
Input: arr[] = {1, 2, 3}
Output: 9
Naive approach: The simple solution is to iterate through every possible pair and add them to a set and then find out the size of the set.
Below is the implementation of the above approach:
C++
#include <bits/stdc++.h>
using namespace std;
int countUnique( int arr[], int n)
{
set<pair< int , int > > s;
for ( int i = 0; i < n; i++)
for ( int j = 0; j < n; j++)
s.insert(make_pair(arr[i], arr[j]));
return s.size();
}
int main()
{
int arr[] = { 1, 2, 2, 4, 2, 5, 3, 5 };
int n = sizeof (arr) / sizeof (arr[0]);
cout << countUnique(arr, n);
return 0;
}
|
Java
import java.awt.Point;
import java.util.*;
class GFG
{
static int countUnique( int arr[], int n)
{
Set<Point> s = new HashSet<>();
for ( int i = 0 ; i < n; i++)
for ( int j = 0 ; j < n; j++)
s.add( new Point(arr[i], arr[j]));
return s.size();
}
public static void main(String[] args)
{
int arr[] = { 1 , 2 , 2 , 4 , 2 , 5 , 3 , 5 };
int n = arr.length;
System.out.print(countUnique(arr, n));
}
}
|
Python3
def countUnique(arr, n):
s = set ()
for i in range (n):
for j in range (n):
s.add((arr[i], arr[j]))
return len (s)
arr = [ 1 , 2 , 2 , 4 , 2 , 5 , 3 , 5 ]
n = len (arr)
print (countUnique(arr, n))
|
C#
using System;
using System.Collections;
using System.Collections.Generic;
class GFG{
public class store : IComparer<KeyValuePair< int , int >>
{
public int Compare(KeyValuePair< int , int > x,
KeyValuePair< int , int > y)
{
if (x.Key != y.Key)
{
return x.Key.CompareTo(y.Key);
}
else
{
return x.Value.CompareTo(y.Value);
}
}
}
static int countUnique( int []arr, int n)
{
SortedSet<KeyValuePair< int ,
int >> s = new SortedSet<KeyValuePair< int ,
int >>( new store());
for ( int i = 0; i < n; i++)
for ( int j = 0; j < n; j++)
s.Add( new KeyValuePair< int , int >(arr[i], arr[j]));
return s.Count;
}
public static void Main( string []arg)
{
int []arr = { 1, 2, 2, 4, 2, 5, 3, 5 };
int n = arr.Length;
Console.Write(countUnique(arr, n));
}
}
|
Javascript
<script>
function countUnique(arr,n)
{
let s = new Set();
for (let i = 0; i < n; i++)
for (let j = 0; j < n; j++)
s.add((arr[i], arr[j]));
return 5*s.size;
}
let arr = [ 1, 2, 2, 4, 2, 5, 3, 5 ];
let n = arr.length;
document.write(countUnique(arr, n));
</script>
|
Time Complexity: Time complexity of the above implementation is O(n2 Log n). We can optimize it to O(n2) using unordered_set with user defined hash function.
Auxiliary Space: O(n)
Efficient approach: First find out the number of unique elements in an array. Let the number of unique elements be x. Then, the number of unique pairs would be x2. This is because each unique element can form a pair with every other unique element including itself.
Below is the implementation of the above approach:
C++
#include <bits/stdc++.h>
using namespace std;
int countUnique( int arr[], int n)
{
unordered_set< int > s;
for ( int i = 0; i < n; i++)
s.insert(arr[i]);
int count = pow (s.size(), 2);
return count;
}
int main()
{
int arr[] = { 1, 2, 2, 4, 2, 5, 3, 5 };
int n = sizeof (arr) / sizeof (arr[0]);
cout << countUnique(arr, n);
return 0;
}
|
Java
import java.util.*;
class GFG
{
static int countUnique( int arr[], int n)
{
HashSet<Integer> s = new HashSet<>();
for ( int i = 0 ; i < n; i++)
{
s.add(arr[i]);
}
int count = ( int ) Math.pow(s.size(), 2 );
return count;
}
public static void main(String[] args)
{
int arr[] = { 1 , 2 , 2 , 4 , 2 , 5 , 3 , 5 };
int n = arr.length;
System.out.println(countUnique(arr, n));
}
}
|
Python3
def countUnique(arr, n):
s = set ()
for i in range (n):
s.add(arr[i])
count = pow ( len (s), 2 )
return count
if __name__ = = "__main__" :
arr = [ 1 , 2 , 2 , 4 , 2 , 5 , 3 , 5 ]
n = len (arr)
print (countUnique(arr, n))
|
C#
using System;
using System.Collections.Generic;
class GFG
{
static int countUnique( int []arr, int n)
{
HashSet< int > s = new HashSet< int >();
for ( int i = 0; i < n; i++)
{
s.Add(arr[i]);
}
int count = ( int ) Math.Pow(s.Count, 2);
return count;
}
static void Main()
{
int []arr = {1, 2, 2, 4, 2, 5, 3, 5};
int n = arr.Length;
Console.WriteLine(countUnique(arr, n));
}
}
|
Javascript
<script>
function countUnique(arr, n){
let s = new Set();
for (let i = 0; i < n; i++)
{
s.add(arr[i]);
}
let count = Math.pow(s.size, 2);
return count;
}
let arr = [ 1, 2, 2, 4, 2, 5, 3, 5 ];
let n = arr.length;
document.write(countUnique(arr, n));
</script>
|
Time Complexity: O(n)
Auxiliary Space: O(n)